module ArrayTransform::Callable

  def self.included(base)
    base.class_eval do
      prepend(Callable)
      extend(ClassMethods)
    end
  end

  module Callable
    def call
      super
    end
  end

  module ClassMethods
    def call(*args, &block)
      new(*args, &block).tap do |callable|
        callable.call
      end
    end
  end

end
