module ArrayTransform::Operations

  class AddColumn
    include ArrayTransform::Callable

    def initialize(
      cell_operation:,
      data:,
      new_column_header: nil
    )
      @cell_operation = cell_operation
      @data = data
      @new_column_header = new_column_header
    end

    attr_reader :data

    def call
      add_column
    end

    private

    attr_reader :cell_operation, :new_column_header

    def add_column
      data.each.with_index do |row, row_index|
        row << cell_operation.call(row_index)
      end
      new_column_header && data[0][-1] = new_column_header
    end
  end

end
