module ArrayTransform::Operations

  class AddIndexColumn
    include ArrayTransform::Callable

    def initialize(
      new_column_header: nil,
      data:,
      index_offset: 0
    )
      @new_column_header = new_column_header
      @data = data
      @index_offset = index_offset
    end

    attr_reader :data

    def call
      AddColumn.call(
        cell_operation: -> (row_index) { row_index + index_offset },
        data: data,
        new_column_header: new_column_header
      )
    end

    private

    attr_reader :new_column_header, :index_offset
  end

end
