module ArrayTransform::Operations

  class UpdateRow
    include ArrayTransform::Callable

    def initialize(
      cell_operation:,
      data:,
      row_offset: 0
    )
      @cell_operation = cell_operation
      @data = data
      @row_offset = row_offset
    end

    attr_reader :data

    def call
      modify_row
    end

    private

    attr_reader :cell_operation, :row_offset

    def modify_row
      data[row_offset] && data[row_offset].each_with_index do |value, index|
        data[row_offset][index] = cell_operation.call(value)
      end
    end
  end

end
